using SDL;
using SDLGraphics;
using SDLImage;
using SDLMixer;
using SDLTTF;
using Gee;

namespace vProcessing {
  
  class vectorGraphics {
    
    /**
     * an array to store the poinhs in...
     */
    private ArrayList<Point> myPointArray;
    
    /**
     * The last poist to be renderd
     */
    private Point lastPoint;
    
    private Point firstPoint;
    
    public vectorGraphics() {
      myPointArray = new ArrayList<Point>();
    }
    
    
    /**
     * Add a point (x and y) to the array.
     */
    public void addPoint(int16 x, int16 y){
      Point tempPoint = new Point(x, y);
      myPointArray.add(tempPoint);
    }
    
    /**
     * Clear the points...
     */
    public void clearPoints() {
      myPointArray.clear();
    }
    
    /**
     * Draw the array to a surface..
     * @param surface The surface that is poing te be draw to
     * @param color The color of the lines
     * @param goBack if a line is to be put between the last and the first point
     */
    public void draw(SDL.Surface surface, uint32 color, bool goBack) {
      lastPoint = myPointArray.get(0);
      firstPoint = lastPoint;
      foreach(Point p in myPointArray){
        SDLGraphics.Line.color(surface, lastPoint.x, lastPoint.y, p.x, p.y, color);
        lastPoint = p;
      }
      
      if(goBack) {
        SDLGraphics.Line.color(surface, lastPoint.x, lastPoint.y,
                              myPointArray.get((int)myPointArray.size).x,
                              myPointArray.get((int)myPointArray.size).y
                              , color);
      }
      
    }
  }
  
}

